const search_box = document.getElementById("search")
const results = document.getElementById("results")
const result_count = document.getElementById("result_count")
const search_btn = document.getElementById("search_btn");

function search()
{
	if( search_box.value.trim().length === 0)
	{
		return openModal("Huh?", "Gebe bitte einen Künstler, Titel oder ein Album ein");
	}
	search_btn.disabled = true;
	httpGetAsync("/api/search-song/" + search_box.value, (response, status) => {
		search_btn.disabled = false;


		if ( status === 429 )
			return openModal("Nicht so schnell!", "Lass Spotify etwas Zeit zwischen deinen Suchanfragen.");
		else if(status !== 200)
			return openModal("Oops!", "Etwas ist schiefgelaufen.<br>Versuche es später erneut oder kontaktiere die Verwaltung.");
		results.innerHTML = "";


		let i = 1;
		for( let e of response )
		{
			let tr = document.createElement("tr");
			tr.onclick = () => add(e.uri);

			let cover = document.createElement("td");
			let cover_img = document.createElement("img");
			cover_img.src = e.cover;
			cover_img.classList.add("cover");
			cover_img.style.width = "30px";
			cover_img.style.height = "30px";
			cover.append(cover_img);

			let artist = document.createElement("td");
			artist.innerText = e.artist;

			let name = document.createElement("td");
			name.innerText = e.name;

			tr.append(cover,artist, name);

			results.append(tr);
			i++;
		}

		result_count.innerText = i + " Ergebnisse";


	});
}

search_box.addEventListener("keyup", function(event) {
	if (event.key === "Enter") {
		search();
	}
});

function add(uri)
{
	if( Date.now() < last_add+1000) // Anti double click
		return;


	httpPostAsync("/api/push-queue", {uri: uri}, (r, status) => {
		if( status === 429 )
			return openModal("Nicht so schnell 👋🛑", "Lass den anderen auch etwas Zeit ⏲️<br>Du darfst erneut in " + Math.round(r.retry_in) + "s");
		else if ( status === 404 )
			return openModal("The Party is over!", "Gerade wird keine Musik gespielt, weswegen auch keine Warteschlange existiert :(");
		else if(status === 200)
		{
			results.innerText = "";
			result_count.innerText = "0 Ergebnisse";
			search_box.value = "";
			last_add = Date.now();
			return openModal("Hinzugefügt! ➕", "Dein Titel wurde der Warteschlange hinzugefügt");
		}
		else
		{
			return openModal("Oops!", "Etwas ist schiefgelaufen.<br>Versuche es später erneut oder kontaktiere die Verwaltung.");
		}
	})

}